Bug Hunting Session
Bug 74230 - ODF documents written by 4.2.0.4 and loaded by 4.1 may show drawing objects with different colour
Summary: ODF documents written by 4.2.0.4 and loaded by 4.1 may show drawing objects w...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: filters and storage (show other bugs)
Version:
(earliest affected)
4.2.0.4 release
Hardware: All All
: medium major
Assignee: Michael Stahl (CIB)
URL:
Whiteboard: odf target:4.3.0 target:4.2.1
Keywords: regression
Depends on:
Blocks:
 
Reported: 2014-01-30 15:47 UTC by kaesezeh
Modified: 2015-08-18 21:57 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments
example (28.63 KB, application/vnd.oasis.opendocument.text)
2014-01-30 15:47 UTC, kaesezeh
Details

Note You need to log in before you can comment on or make changes to this bug.
Description kaesezeh 2014-01-30 15:47:53 UTC
Created attachment 93062 [details]
example

After having updated from 4.1 to 4.2.0.4 (which I can't choose in the Version field above), Writer shows all lines in a document (several dozens that introduce structure in tables) that were formerly black now as blue (see attachment) This is annoying because an update shouldn't require me to change things like that and which is particularly annoying because Writer doesn't allow to highlight several things at the same time (with Shift or Ctrl) so I have to do each line separately. Seriously, I like LO and proselytize my students all the time, but crap like this make one wonder why with each update x bugs get fixed and y bugs get introduced ...
Comment 1 Thomas van der Meulen 2014-01-30 18:14:23 UTC
Thank you for your bug report,
Yes, the lines are changed to blue in 4.2.0.4 and black in 4.1.3.2. 

Test details: 
Version: 4.2.0.4
Build ID: 05dceb5d363845f2cf968344d7adab8dcfb2ba71
os: mac osx 10.9.1
Comment 2 Michael Stahl (CIB) 2014-02-06 21:49:37 UTC
what fails is creating a document with a line (default color),
storing it in 4.2.0.4 and then loading it in 4.1.5.3.

the line is then black whereas 4.2 displays it as blue like when it was created.

hmm... in neither version does the line in the document have
an explicit color set, both look identical:

  <draw:line text:anchor-type="paragraph" draw:z-index="0" draw:style-name="gr1" draw:text-style-name="P1" svg:x1="1.766cm" svg:y1="2.208cm" svg:x2="14.836cm" svg:y2="1.679cm">

 <style:style style:name="gr1" style:family="graphic">
   <style:graphic-properties draw:textarea-horizontal-align="center" draw:textarea-vertical-align="middle" style:run-through="foreground" style:wrap="run-through" style:number-wrapped-paragraphs="no-limit" style:vertical-pos="from-top" style:vertical-rel="paragraph" style:horizontal-pos="from-left" style:horizontal-rel="paragraph"/>
  </style:style>

... but ... the 4.1 doc has some color attributes in its graphic defaults:

  <style:default-style style:family="graphic">
   <style:graphic-properties svg:stroke-color="#3465af" draw:fill-color="#729fcf" fo:wrap-option="no-wrap" draw:shadow-offset-x="0.3cm" draw:shadow-offset-y="0.3cm" draw:start-line-spacing-horizontal="0.283cm" draw:start-line-spacing-vertical="0.283cm" draw:end-line-spacing-horizontal="0.283cm" draw:end-line-spacing-vertical="0.283cm" style:flow-with-text="false"/>

... whereas in 4.2:

  <style:default-style style:family="graphic">
   <style:graphic-properties fo:wrap-option="no-wrap" draw:shadow-offset-x="0.3cm" draw:shadow-offset-y="0.3cm" draw:start-line-spacing-horizontal="0.283cm" draw:start-line-spacing-vertical="0.283cm" draw:end-line-spacing-horizontal="0.283cm" draw:end-line-spacing-vertical="0.283cm" style:flow-with-text="false"/>

... no svg:stroke-color="#3465af" draw:fill-color="#729fcf" !

regression from commit c0eb5e7772c848806db8ab461f77f9549c1d8b2b
Comment 3 Michael Stahl (CIB) 2014-02-07 18:00:45 UTC
so effectively what has changed is that Writer for loaded documents now has different pool defaults for fill color, stroke color, hatch color.

the fill color and stroke color defaults are easily written,
but not the hatch color default.

it is possible to create a shape with a hatch that uses the pool default,
by opening the Area dialog and setting Fill to "Hatching" and then
not selecting any of the list entries.

this results in something like;

   <style:graphic-properties draw:fill="hatch" draw:fill-hatch-solid="false" 

... with the draw:fill-hatch-name missing.

it would perhaps be possible to shoehorn a draw:fill-hatch-name referencing
a default draw:hatch onto the graphics default style, but older
OOo/LO versions are unable to load such a contraption.

so for now simply tweak the UI so that documents relying on pool defaults
for this cannot be created any more.
Comment 4 Commit Notification 2014-02-07 18:01:12 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=45d3577bc5726eee44f491fd30a7f11dc428431a

fdo#74230: ODF export: write stroke and fill color in graphic defaults



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 5 Commit Notification 2014-02-07 18:01:27 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=38d0047da7f964c862360b48d88cc869ad376b6b

related: fdo#74230: Area tab page: prevent default gradient/hatch/bitmap



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 6 Michael Stahl (CIB) 2014-02-07 18:06:49 UTC
forgot to mention that this bug affects at least Calc too.
Comment 7 Commit Notification 2014-02-09 10:10:42 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-4-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=63756b6bd3bc1c755b7a703fdbcc164fbff6acc2&h=libreoffice-4-2

fdo#74230: ODF export: write stroke and fill color in graphic defaults


It will be available in LibreOffice 4.2.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 8 Commit Notification 2014-02-09 10:12:01 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-4-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8ef53812f161758826f9a4396f7d6416b29c5f97&h=libreoffice-4-2

related: fdo#74230: Area tab page: prevent default gradient/hatch/bitmap


It will be available in LibreOffice 4.2.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2015-08-18 15:32:11 UTC
Varun committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=c89207eaa4ea1b55be46ea083cce174a373035b2

Added Test for tdf#74230 ODF export stroke and fill in graphic defaults

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.